# Color
team modify chess_selected color green

# Move
execute as @e[tag=chess_placeholder,tag=chess_select] if entity @e[tag=chess_selected,tag=white] run scoreboard players set *Move ChessNumber 0
execute as @e[tag=chess_placeholder,tag=chess_select] if entity @e[tag=chess_selected,tag=black] run scoreboard players set *Move ChessNumber 1
execute as @e[tag=chess_placeholder,tag=chess_select] run tag @e[tag=pawn_moved] remove pawn_moved
    
execute as @e[tag=chess_placeholder,tag=chess_select] at @s if entity @e[tag=chess,distance=..0.1,tag=!chess_placeholder] at @s as @p run function chess:capture
execute as @e[tag=chess_placeholder,tag=chess_select] at @s run tp @e[tag=chess_selected] ~ ~ ~

execute unless entity @e[tag=chess_promote] as @e[tag=chess_placeholder,tag=chess_select] if entity @e[tag=chess_selected,tag=white] run schedule function chess:checkmate/white/order 2t
execute unless entity @e[tag=chess_promote] as @e[tag=chess_placeholder,tag=chess_select] if entity @e[tag=chess_selected,tag=black] run schedule function chess:checkmate/black/order 2t

# Moved
execute as @e[tag=chess_placeholder,tag=chess_select] run tag @e[tag=chess_selected] add moved
execute as @e[tag=chess_placeholder,tag=chess_select] run tag @e[tag=chess_selected,tag=pawn_moved] remove pawn_moved
execute as @e[tag=chess_placeholder,tag=chess_select,tag=pawn_placeholder] run tag @e[tag=chess_selected] add pawn_moved

# Pawn Eat
execute as @e[tag=chess_placeholder,tag=chess_select,tag=eat_placeholder] at @s if entity @e[tag=chess_selected,tag=white] positioned ~ ~ ~-1 run playsound minecraft:entity.zombie.attack_wooden_door master @a ~ ~ ~ 0.7 0
execute as @e[tag=chess_placeholder,tag=chess_select,tag=eat_placeholder] at @s if entity @e[tag=chess_selected,tag=white] positioned ~ ~ ~-1 run kill @e[tag=chess,distance=..0.1,tag=!chess_placeholder]

execute as @e[tag=chess_placeholder,tag=chess_select,tag=eat_placeholder] at @s if entity @e[tag=chess_selected,tag=black] positioned ~ ~ ~1 run playsound minecraft:entity.zombie.attack_wooden_door master @a ~ ~ ~ 0.7 0
execute as @e[tag=chess_placeholder,tag=chess_select,tag=eat_placeholder] at @s if entity @e[tag=chess_selected,tag=black] positioned ~ ~ ~1 run kill @e[tag=chess,distance=..0.1,tag=!chess_placeholder]

# Castle
execute as @e[tag=chess_placeholder,tag=chess_select,tag=castle_placeholder] at @s if entity @e[tag=chess_selected,tag=white] positioned ~-1 ~ ~ run tp @e[tag=tower,tag=white,distance=..0.1] ~2 ~ ~    
execute as @e[tag=chess_placeholder,tag=chess_select,tag=castle_placeholder] at @s if entity @e[tag=chess_selected,tag=white] positioned ~2 ~ ~ run tp @e[tag=tower,tag=white,distance=..0.1] ~-3 ~ ~

execute as @e[tag=chess_placeholder,tag=chess_select,tag=castle_placeholder] at @s if entity @e[tag=chess_selected,tag=black] positioned ~-1 ~ ~ run tp @e[tag=tower,tag=black,distance=..0.1] ~2 ~ ~    
execute as @e[tag=chess_placeholder,tag=chess_select,tag=castle_placeholder] at @s if entity @e[tag=chess_selected,tag=black] positioned ~2 ~ ~ run tp @e[tag=tower,tag=black,distance=..0.1] ~-3 ~ ~
    
#
execute as @e[tag=chess_placeholder,tag=chess_select] run playsound minecraft:block.barrel.open master @a ~ ~ ~ 0.4 1.5
execute as @e[tag=chess_placeholder,tag=chess_select] run kill @e[tag=check_placeholder]

# Promote
execute as @e[tag=white,tag=pawn] at @s unless block ~ ~-1 ~1 #chess:board positioned ~ ~ ~ run function chess:promote/white/spawn
execute as @e[tag=black,tag=pawn] at @s unless block ~ ~-1 ~-1 #chess:board positioned ~ ~ ~ run function chess:promote/black/spawn

# Reset
function chess:reset

# Select
tag @s remove chess_select
tag @s add chess_selected
team join chess_selected @s

# Placeholders
execute if entity @s[tag=pawn] at @s run function chess:placeholders/pawn
execute if entity @s[tag=knight] at @s run function chess:placeholders/knight
execute if entity @s[tag=bishop] at @s run function chess:placeholders/bishop
execute if entity @s[tag=tower] at @s run function chess:placeholders/tower
execute if entity @s[tag=queen] at @s run function chess:placeholders/bishop
execute if entity @s[tag=queen] at @s run function chess:placeholders/tower
execute if entity @s[tag=king] at @s run function chess:placeholders/king
    
# Incavllid Placeholder Check
execute as @e[tag=chess_placeholder] at @s run function chess:check/placeholder/piece
execute as @e[tag=castle_placeholder] at @s unless entity @e[tag=chess_placeholder,tag=!castle_placeholder,distance=..1.2] run kill @s
    
# Color
execute unless entity @e[tag=chess_placeholder,tag=!check_placeholder] run team modify chess_selected color red