#---------------------------------------------------------
# This Datapack was made by CommandGeek
# Please do not copy or credit this as your own work!
# Youtube: www.youtube.com/CommandGeek
#---------------------------------------------------------

# Raycast
scoreboard players set @a ChessRaycast 100
tag @e[tag=chess_select] remove chess_select

execute as @a[tag=chess_white,nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{CustomModelData:1}}}] at @s anchored eyes run function chess:raycast
execute as @a[tag=chess_black,nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{CustomModelData:1}}}] at @s anchored eyes run function chess:raycast

# Placeholder Glowing
execute as @e[tag=chess_placeholder] run data modify entity @s ArmorItems[3] set value {id:"ghast_spawn_egg",Count:1b,tag:{CustomModelData:13}}
execute as @e[tag=chess_placeholder,tag=chess_select] run data modify entity @s ArmorItems[3].tag.CustomModelData set value 14

# Glowing
effect give @e[tag=chess_select,tag=!chess_placeholder] minecraft:glowing 1 1 true
effect give @e[tag=chess_selected] minecraft:glowing 1 1 true
effect clear @e[tag=chess,tag=!chess_select,tag=!chess_selected] minecraft:glowing

# Clicking
execute if score *Move ChessNumber matches 1 as @a[tag=chess_white,scores={ChessCarrot=1..},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{CustomModelData:1}}}] at @s run function chess:click
execute if score *Move ChessNumber matches 0 as @a[tag=chess_black,scores={ChessCarrot=1..},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{CustomModelData:1}}}] at @s run function chess:click

execute as @a[scores={ChessCarrot=1..},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{CustomModelData:2}}}] as @s at @e[tag=chess_remove] run function chess:capture

execute unless score *Move ChessNumber matches -1 as @a[scores={ChessCarrot=1..},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{CustomModelData:3}}}] at @s run function chess:play_progress
execute if score *Move ChessNumber matches -1 if entity @p[tag=chess_white] if entity @p[tag=chess_black] as @a[scores={ChessCarrot=1..},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{CustomModelData:3}}}] at @s run function chess:play
execute if score *Move ChessNumber matches -1 unless entity @p[tag=chess_black] as @a[scores={ChessCarrot=1..},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{CustomModelData:3}}}] at @s run function chess:play_fail
execute if score *Move ChessNumber matches -1 unless entity @p[tag=chess_white] as @a[scores={ChessCarrot=1..},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{CustomModelData:3}}}] at @s run function chess:play_fail
execute unless score *Move ChessNumber matches -1 as @a[scores={ChessCarrot=1..},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{CustomModelData:4}}}] at @s run function chess:leave_game_queue

scoreboard players set @a[scores={ChessCarrot=1..}] ChessCarrot 0

# Chess Number
execute unless score *Move ChessNumber matches -1..1 run scoreboard players set *Move ChessNumber 0

# Timer
execute unless score *White ChessMin matches ..-1 unless score *Move ChessNumber matches -1 as @a[tag=chess_white] at @s run function chess:timer/actionbar
execute unless score *White ChessMin matches ..-1 unless score *Move ChessNumber matches -1 as @a[tag=chess_black] at @s run function chess:timer/actionbar

execute if score *Move ChessNumber matches 1 run scoreboard players remove *White ChessTick 1
execute if score *Move ChessNumber matches 0 run scoreboard players remove *Black ChessTick 1

execute if score *White ChessTick matches ..-1 run scoreboard players remove *White ChessSec 1
execute if score *White ChessSec matches ..-1 run scoreboard players remove *White ChessMin 1
execute if score *White ChessSec matches ..-1 run scoreboard players set *White ChessSec 59
execute if score *White ChessTick matches ..-1 run scoreboard players set *White ChessTick 19
    
execute if score *Black ChessTick matches ..-1 run scoreboard players remove *Black ChessSec 1
execute if score *Black ChessSec matches ..-1 run scoreboard players remove *Black ChessMin 1
execute if score *Black ChessSec matches ..-1 run scoreboard players set *Black ChessSec 59
execute if score *Black ChessTick matches ..-1 run scoreboard players set *Black ChessTick 19

# No Time
execute if score *White ChessMin matches 0 if score *White ChessSec matches 0 if score *White ChessTick matches 1 as @p[tag=chess_black] at @s run function chess:win/black
execute if score *Black ChessMin matches 0 if score *Black ChessSec matches 0 if score *Black ChessTick matches 1 as @p[tag=chess_white] at @s run function chess:win/white

# Forfeit
execute unless score *Move ChessNumber matches -1 if entity @p[tag=chess_white] unless entity @p[tag=chess_black] as @p[tag=chess_white] at @s run function chess:win/white
execute unless score *Move ChessNumber matches -1 if entity @p[tag=chess_black] unless entity @p[tag=chess_white] as @p[tag=chess_black] at @s run function chess:win/black

# Remove Piece
tag @e[tag=chess_remove] remove chess_remove
scoreboard players set @a ChessRaycast 100
execute as @a[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{CustomModelData:2}}}] at @s anchored eyes run function chess:raycast_remove

team join chess_remove @e[tag=chess_remove]
team leave @e[team=chess_remove,tag=!chess_remove]
effect give @e[tag=chess_remove] minecraft:glowing 1 1 true

# Sneaking
tag @a[tag=chess_sneaked,predicate=!chess:sneaking] remove chess_sneaked
execute as @a[predicate=chess:sneaking,tag=!chess_sneaked] at @s run function chess:sneak

# Teams
execute if score *Move ChessNumber matches -1 run title @a[tag=chess_white,tag=!chess_black] actionbar {"text":"You are on Team White","color":"white"}
execute if score *Move ChessNumber matches -1 run title @a[tag=chess_black,tag=!chess_white] actionbar {"text":"You are on Team Black","color":"black"}    
execute if score *Move ChessNumber matches -1 run title @a[tag=chess_black,tag=chess_white] actionbar {"text":"You are on Both Teams","color":"gold"}
    
# Leave Game
execute as @a[scores={ChessLeave=1..}] at @s run function chess:leave_game
execute unless score *Move ChessNumber matches -1 unless entity @p[tag=chess_white] unless entity @p[tag=chess_black] run scoreboard players set *Move ChessNumber -1
            
# Theme
execute as @a[nbt={Inventory:[{Slot:-106b,id:"minecraft:carrot_on_a_stick",tag:{CustomModelData:3}}]}] unless data entity @s SelectedItem at @s run function chess:theme/board/click

# Setup
execute as @e[tag=spawn_chess_board] at @s positioned ~ ~-1 ~ run function chess:setup/board

# Team Selection
execute unless score *Queue ChessNumber matches 1 if score *Move ChessNumber matches -1 at @e[tag=chess,tag=king] run particle minecraft:composter ~ ~2 ~ 0.03 0.03 0.03 0 1
execute unless score *Queue ChessNumber matches 1 if score *Move ChessNumber matches -1 at @e[tag=white,tag=king] as @p[distance=..1] unless entity @s[tag=chess_white] run function chess:team/white
execute unless score *Queue ChessNumber matches 1 if score *Move ChessNumber matches -1 at @e[tag=black,tag=king] as @p[distance=..1] unless entity @s[tag=chess_black] run function chess:team/black
    
execute if score *Move ChessNumber matches -1 as @a[tag=chess_white] at @s unless entity @e[tag=white,tag=king,distance=..20] run function chess:team/white_leave
execute if score *Move ChessNumber matches -1 as @a[tag=chess_black] at @s unless entity @e[tag=black,tag=king,distance=..20] run function chess:team/black_leave
        
# Pieces
execute unless score *Move ChessNumber matches -1 unless entity @e[tag=white,tag=!king] unless entity @e[tag=black,tag=!king] at @e[tag=king,sort=random,limit=1] run function chess:win/stalemate
            
# Queue
execute store result score *QueueTotal ChessNumber if entity @a[scores={ChessQueue=1..}]
execute as @a[scores={ChessQueue=1..}] run function chess:queue/update/position
execute as @a[scores={ChessQueue=1..}] run function chess:queue/update/actionbar
execute if score *Queue ChessNumber matches 1 if score *Move ChessNumber matches -1 if entity @a[scores={ChessQueue=1}] if entity @a[scores={ChessQueue=2}] run function chess:queue/game/start

# Face Player
execute as @e[tag=chess_face_player] at @s run tp @s ~ ~ ~ facing entity @p
execute as @e[tag=chess_face_player,tag=chess_queue_game] run kill @e[tag=chess_queue_game,tag=!chess_face_player]
execute as @e[tag=chess_face_player,tag=chess_queue_spawn] run kill @e[tag=chess_queue_spawn,tag=!chess_face_player]
tag @e[tag=chess_face_player] remove chess_face_player